package fr.sanchezm.attestationsCovid19.ui.attestations

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.fragment.app.Fragment
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import fr.sanchezm.attestationsCovid19.PdfViewerActivity
import fr.sanchezm.attestationsCovid19.R
import fr.sanchezm.attestationsCovid19.databinding.FragmentAttestationsBinding
import fr.sanchezm.attestationsCovid19.utilities.InjectorUtils

class AttestationsFragment : Fragment() {

    private lateinit var attestationsViewModel: AttestationsViewModel

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        initializeUi()
        val binding = DataBindingUtil.inflate<FragmentAttestationsBinding>(
            inflater,
            R.layout.fragment_attestations,
            container,
            false
        ).apply {
            this.lifecycleOwner = this@AttestationsFragment
            this.viewModel = attestationsViewModel
        }

        bindMessage()
        return binding.root
    }

    private fun bindMessage() {
        attestationsViewModel.startActivity.observe(viewLifecycleOwner, Observer {
            it.getContentIfNotHandled()?.let { createAtPdf ->
                val intent = Intent(context, PdfViewerActivity::class.java).apply {
                    putExtra("createAt", createAtPdf)
                }
                startActivity(intent)
            }
        })
    }

    private fun initializeUi() {
        val factory = context?.let { InjectorUtils.provideAttestationViewModel(it) }
        attestationsViewModel = factory?.let {
            ViewModelProvider(this, it)
                .get(AttestationsViewModel::class.java)
        }!!
    }
}