package fr.sanchezm.attestationsCovid19.ui.attestations

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import fr.sanchezm.attestationsCovid19.data.repository.AttestationRepository
import fr.sanchezm.attestationsCovid19.utilities.Event

class AttestationsViewModel(private val attestationRepository: AttestationRepository) : ViewModel() {

    private var attestationCreateAt: Long
    private val _startActivity = MutableLiveData<Event<Long>>()
    private val _attestationName = MutableLiveData<String>()

    val startActivity: LiveData<Event<Long>> =
        _startActivity

    val attestationName: LiveData<String> =
        _attestationName

    fun onClick() {
        _startActivity.value = Event(attestationCreateAt)
    }

    init {
        val attestation = attestationRepository.getAttestations().value?.last()
        attestationCreateAt = attestation?.createAt!!
        _attestationName.value = "${attestation.profile.firstName} ${attestation.profile.lastName}"
    }
}